#!/usr/bin/env python3

import sys
import os
import subprocess
import re
import json

# with open("/root/PythonTestFile", 'w') as f:
#     f.write("Printing Hook Parameters:\n")
#     for i in range(0, len(sys.argv)):
#         f.write("Arg " + str(i) + ": " + sys.argv[i] + "\n")

# JetBackup 還原類型
JETBACKUP_RESTORE_TYPE: str = sys.argv[1]
# JetBackup 帳號 ID
JETBACKUP_ACCOUNT_ID: str = sys.argv[3]
# cPanel 帳號
CPANEL_ACCOUNT: str = sys.argv[4]
# 備份項目列表
JETBACKUP_BACKUP_ITEMS: list = sys.argv[5].split(",")
# 抓取備份目標 ID
a = subprocess.Popen(["jetbackup5api", "-F", "getBackupItem", "-D", f"_id={JETBACKUP_BACKUP_ITEMS[0]}"], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
DESTINATION_ID = re.findall(r'destination: (.*)', a.stdout.read().decode())[0]
# 備份任務 ID
BACKUPJOB_ID = ""
# SNAP ID
SNAPID = ""
a = subprocess.Popen(["jetbackup5api", "-F", "listBackupJobs", "-O", "json"], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
_backup_jobs = json.loads(a.stdout.read().decode())
for _backup_job in _backup_jobs["data"]["jobs"]:
    if len(_backup_job['destination']) > 1:
        continue
    if _backup_job['destination'][0] == DESTINATION_ID:
        BACKUPJOB_ID = _backup_job['_id']
        break

# 修正 public_html 權限
os.popen(f"chown -v {CPANEL_ACCOUNT}:nobody /home/{CPANEL_ACCOUNT}/public_html")
os.popen(f"chmod -v 750 /home/{CPANEL_ACCOUNT}/public_html")

# 修正沒有放在 public_html 範圍內網站根目錄權限
website_folders = os.popen(f"grep -i documentroot /var/cpanel/userdata/{CPANEL_ACCOUNT}/* | grep -v '.cache\|_SSL' | awk '{{print $2}}'").read().split("\n")[:-1]
for _folder in website_folders:
    os.popen(f"chown -v {CPANEL_ACCOUNT}:nobody {_folder}")
    os.popen(f"chmod -v 750 {_folder}")

# 修正 cPanel 帳號底下 etc 權限，主要是 mail 相關的
os.popen(f"/scripts/mailperm --verbose {CPANEL_ACCOUNT}")

# 抓取備份索引 ex. snap.XX
with open(f"/backup/jetbackup/jetbackup_1_1_{BACKUPJOB_ID}/{CPANEL_ACCOUNT}_{JETBACKUP_ACCOUNT_ID}/jetbackup.index", 'r') as f:
    jetbackup_index = json.loads(f.read())
    for _snapid in jetbackup_index:
        if _snapid.find(JETBACKUP_BACKUP_ITEMS[0]):
            SNAPID = _snapid
            break

# 從備份目錄抓取並還原 .cl.selector
os.popen(f"cp -v /backup/jetbackup/jetbackup_1_1_{BACKUPJOB_ID}/{CPANEL_ACCOUNT}_{JETBACKUP_ACCOUNT_ID}/{SNAPID}/config/homedir/.cl.selector/* /home/{CPANEL_ACCOUNT}/.cl.selector/")
os.popen(f"chown -vR {CPANEL_ACCOUNT}:{CPANEL_ACCOUNT} /home/{CPANEL_ACCOUNT}/.cl.selector/*")

# 重新套用 PHP 設定
cagefs_prefix = os.popen(f"/usr/sbin/cagefsctl --getprefix {CPANEL_ACCOUNT}").read().strip()
os.popen(f"rm -rf /var/cagefs/{cagefs_prefix}/{CPANEL_ACCOUNT}/etc/cl.selector")
os.popen(f"rm -rf /var/cagefs/{cagefs_prefix}/{CPANEL_ACCOUNT}/etc/cl.php.d")
os.popen(f"/usr/sbin/cagefsctl --force-update-etc {CPANEL_ACCOUNT}")

# 重新套用 cPanel 方案
cPanel_Plan = os.popen(f'grep "^PLAN=" /backup/jetbackup/jetbackup_1_1_{BACKUPJOB_ID}/{CPANEL_ACCOUNT}_{JETBACKUP_ACCOUNT_ID}/{SNAPID}/config/cp/{CPANEL_ACCOUNT} | cut -d"=" -f2').read().strip()
os.popen(f"whmapi1 --output=jsonpretty changepackage user='{CPANEL_ACCOUNT}' pkg='{cPanel_Plan}'")

# 重套用磁碟空間
Disk_Limit = os.popen(f'grep "^DISK_BLOCK_LIMIT=" /backup/jetbackup/jetbackup_1_1_{BACKUPJOB_ID}/{CPANEL_ACCOUNT}_{JETBACKUP_ACCOUNT_ID}/{SNAPID}/config/cp/{CPANEL_ACCOUNT} | cut -d"=" -f2').read().strip()
os.popen(f"whmapi1 --output=jsonpretty editquota user='{CPANEL_ACCOUNT}' quota='{int(int(Disk_Limit) / 1024)}'")

# 重套用流量限制
Bandwidth_Limit = os.popen(f'grep "^BWLIMIT=" /backup/jetbackup/jetbackup_1_1_{BACKUPJOB_ID}/{CPANEL_ACCOUNT}_{JETBACKUP_ACCOUNT_ID}/{SNAPID}/config/cp/{CPANEL_ACCOUNT} | cut -d"=" -f2').read().strip()
if Bandwidth_Limit == "unlimited":
    os.popen(f"whmapi1 --output=jsonpretty limitbw user='{CPANEL_ACCOUNT}' bwlimit='unlimited'")
else:
    os.popen(f"whmapi1 --output=jsonpretty limitbw user='{CPANEL_ACCOUNT}' bwlimit='{int(int(Bandwidth_Limit) / 1024 / 1024)}'")

# 重掛一次 CageFS
os.popen(f"/usr/sbin/cagefsctl --remount {CPANEL_ACCOUNT}")

